diff a/src/jdk.compiler/share/classes/com/sun/tools/javac/comp/AttrContext.java b/src/jdk.compiler/share/classes/com/sun/tools/javac/comp/AttrContext.java
--- a/src/jdk.compiler/share/classes/com/sun/tools/javac/comp/AttrContext.java
+++ b/src/jdk.compiler/share/classes/com/sun/tools/javac/comp/AttrContext.java
@@ -124,10 +124,12 @@
      *  but this may not be true during the window a method is looked up in enclosing
      *  contexts (JDK-8145466)
      */
     JCTree preferredTreeForDiagnostics;
 
+    boolean instanceInitializerBlock = false;
+
     /** Duplicate this context, replacing scope field and copying all others.
      */
     AttrContext dup(WriteableScope scope) {
         AttrContext info = new AttrContext();
         info.scope = scope;
@@ -147,10 +149,11 @@
         info.isAnonymousDiamond = isAnonymousDiamond;
         info.isNewClass = isNewClass;
         info.preferredTreeForDiagnostics = preferredTreeForDiagnostics;
         info.visitingServiceImplementation = visitingServiceImplementation;
         info.allowProtectedAccess = allowProtectedAccess;
+        info.instanceInitializerBlock = instanceInitializerBlock;
         return info;
     }
 
     /** Duplicate this context, copying all fields.
      */
